.setcpu		"6502"
.debuginfo	off

.include        "cbm_kernal.inc"
; see: https://www.mdawson.net/vic20chrome/vic20/docs/kernel_disassembly.txt
; and: https://sta.c64.org/cbm64mem.html
; and: https://www.pagetable.com/?p=926

.if .def(__VIC20__) || .def(__C64__) || .def(__PET__)
	RS232_RX_END   := $029B
	RS232_RX_START := $029C
	RS232_TX_END   := $029E
	RS232_TX_START := $029D

	RS232_RX_PTR := $F7
	RS232_TX_PTR := $F9
.endif

.segment	"DATA"

	_fname: .byte 6

.segment	"CODE"

.export _open_ser
.proc _open_ser: near
	jsr CLALL   ;FFE7, close all
	lda #$80
	jsr SETMSG  ;FF90, control kernal messages
	lda #2
	ldx #2
	ldy #$FF
	jsr SETLFS  ;FFBA, set A..logical, X..device, Y..secondary
	lda #1
	ldx #<(_fname)
	ldy #>(_fname)
	jsr SETNAM  ;FFBD, filename A..len, X..nam_lo, y..nam_hi
	jmp OPEN    ;FFC0, open
.endproc

.export _get_ser
.proc _get_ser: near
	ldy RS232_RX_START
	cpy RS232_RX_END
	beq __get_ser_nochar
	lda (RS232_RX_PTR),y
	inc RS232_RX_START
	ldx #$00	; result positive
	rts
__get_ser_nochar:
	lda #$00
	ldx #$80	; result negative
	rts
.endproc

.export _flush_ser
.proc _flush_ser: near
	lda RS232_RX_END
	sta RS232_RX_START
	rts
.endproc

.export _set_ser
.proc _set_ser: near
	ldx #2
	cmp #1
	beq __set_ser_out
__set_ser_wait:
	ldy RS232_TX_START
	cpy RS232_TX_END	; wait TX done
	bne __set_ser_wait
	jsr CHKIN  ;FFC6, set IN channel X..logical
__set_ser_out:
	jmp CHKOUT  ;FFC9, set OUT channel X..logical
.endproc

.export _put_ser
.proc _put_ser: near
	jmp CHROUT  ;FFD2, send char, A..char
.endproc

.export _close_ser
.proc _close_ser: near
	jsr CLRCH	;FFCC, set std. I/O
	lda #2
	jmp CLOSE	;FFC3, CLOSE
.endproc
